<?php

namespace BitCommunism\Http\Context;


use Dflydev\FigCookies\Cookie;
use Dflydev\FigCookies\Cookies;

trait RequestTraits
{
    /**
     * @var Cookies
     */
    protected $cookies;

    public function getCookies(): Cookies {
        if ($this->cookies === null) {
            $this->cookies = Cookies::fromRequest($this->getRequest());
        }

        return $this->cookies;
    }

    public function getCookie($name): ?Cookie {
        return $this->getCookies()->get($name);
    }

    public function getCookieValue(string $name, string $default = ""): string {
        $cookie = $this->getCookie($name);

        if ($cookie !== null) {
            return $cookie->getValue();
        }

        return $default;
    }
}